scriptencoding utf-8

if !exists('autocommands_loaded') && has('autocmd')
    let autocommands_loaded = 1

    aug miscs
        au CursorHold * silent call CocActionAsync('highlight')
        au User CocJumpPlaceholder call CocActionAsync('showSignatureHelp')
    aug END

    aug inserts
        au BufWinEnter,FocusGained,InsertLeave,WinEnter * call dead#functions#Relativize(1)
        au BufWinLeave,FocusLost,InsertEnter,WinLeave * call dead#functions#Relativize(0)
        au InsertLeave * setlocal nopaste
        au InsertLeave,CompleteDone * if pumvisible() == 0 | pclose | endif
    aug END

    aug file_types
        au BufNewFile ~/doc/blog/*.md 0r ~/.config/nvim/templates/wiki.skeleton
        au FileType gitcommit,gitrebase,gitconfig set bufhidden=delete
        au BufNewFile,BufRead requirements*.txt set syntax=python
        au FileType fzf tnoremap <buffer> <esc> <c-c>
    aug END

    aug status_line
        au VimEnter * call dead#statusline#UpdateInactiveWindows()
        au VimEnter,WinEnter,BufWinEnter * call dead#statusline#RefreshStatusLine('active')
        au WinLeave * call dead#statusline#RefreshStatusLine('inactive')
    aug END

    aug on_save
        au BufWritePre * :%s/\s\+$//e
        au BufWritePost *xresources !xrdb %
        au BufWritePost *sxhkdrc !pkill -USR1 sxhkd
        au BufWritePost *.tex !pdflatex %
        au QuitPre * if empty(&buftype) | lclose | endif
    aug END

    aug MyTerminal
        au TermOpen * setlocal wrap nonumber norelativenumber noruler signcolumn=no
        au TermOpen * set laststatus=0 showtabline=0
       " workaround for a segfault: https://github.com/neovim/neovim/issues/11548#issuecomment-583081783
       " immediately enter insert mode when switching to a terminal
       au BufEnter term://* startinsert!
       au TermClose * set laststatus=2 showtabline=2
    aug END
endif
