# Programas
alias \
		vdi='nvim -d' \
		se='sudoedit' \
		gdl='gallery-dl' \
		am='alsamixer' \
		pm='pulsemixer' \
		nb='newsboat -q' \
		v='$EDITOR' \
		play='ncmpcpp' \
		x='xui' \
		z='zathura' \
		py='python ' \
		pyserv='python -m http.server' \
		git='lab' \
		irc='catgirl freenode'

# XBPS
alias \
		xk='xbps-query' \
		deps='xbps-query -vRx' \
		upa='sudo xi' \
		revdeps='xbps-query -vRX' \
		xp='xpkg -m > ~/doc/xbpaketes'

# Tmux
if [[ -n $TMUX ]]; then
  alias txa='tmux switch-client -t'
else
  alias txa='tmux attach-session -t'
fi
alias \
		txn='tmux new-session -s' \
		txk='tmux kill-session -t' \
		txz='tmux kill-server'

# LaTeX
alias \
		lxs='tlmgr search --global' \
		lxl='tlmgr search' \
		lxi='sudo tlmgr install'

# Transmission
alias \
		tsk='pkill transmission-da' \
		ts='transmission-remote' \
		tsl='transmission-remote --list' \

# Dotfiles
alias \
		hxa='hx add -v' \
		hxu='hx add -vu' \
		hxc='hx commit' \
		hxp='hx push' \
		hxs='hx status' \
		hxl='hx log --stat' \
		hxd='hx rm -r --cached' \
		hxr='hx rm --cached'

# MAXIMUM VERBOSITY YIELDS MAXIMUM RESULTS
alias \
		chmod='chmod -v' \
		chown='chown -v' \
		mv='mv -iv' \
		rmdir='rmdir -v' \
		mkdir='mkdir -pv' \
		cp='cp -raiv' \
		rm='rm -Iv' \
		ln='ln -iv' \
		mount='mount -v' \
		umount='umount -v'

# Colores para pintar este twist
alias \
		diff='diff --color=auto' \
		ls='ls -AFpt --color=always --group-directories-first' \
		grep='grep --color=tty -d skip' \
		dmesg='dmesg --color=always' \
		vsv='sudo vsv -c yes' \

# Con opciones por defecto
alias \
		ll='ls -coghptFAB --group-directories-first --time-style=+"%d-%m-%Y %H:%M"' \
		sgrep='grep -R -n -H -C 5 --exclude-dir={.git,.svn,CVS}' \
		lsblk='lsblk -o "KNAME,HOTPLUG,SIZE,FSTYPE,TYPE,LABEL,MOUNTPOINT,UUID,MODEL,SERIAL"' \
		df='df -hT --total' \
		free='free -ht' \
		du='du -sh' \
		ping='ping -c 5' \
		dd='dd status=progress' \
		dfc='dfc -dmT' \
		strim='mpv --jack-port="OBS Jack Input"'

# Comandos
alias \
		sudo='sudo ' \
		reboot='sudo reboot' \
		shutdown='sudo shutdown -h now' \
		path='echo -e ${PATH//:/\\n}' \
		wp='sxiv-rifle ~/img/wallpaper >/dev/null 2>&1' \
		pwn='chmod +x' \
		atl='atool --each --extract' \
		rat='tar -xvJf' \
		um='udevil mount' \
		uu='udevil umount'
